'''
yaartv deccandelight plugin
Copyright (C) 2018 Gujal

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
'''
from _base_ import Scraper
from BeautifulSoup import BeautifulSoup, SoupStrainer
import urlparse, re, requests
import HTMLParser
import xbmcgui

class yaartv(Scraper):
    def __init__(self):
        Scraper.__init__(self)
        self.bu = 'http://yaartv.tv/'
        self.icon = self.ipath + 'yaartv.png'
            
    def get_menu(self):
        mlist = {}
        html = requests.get(self.bu, headers=self.hdr).text
        navmenu = re.findall('<div\s*id="nav">(.+?)</div>',html,re.DOTALL)[0]
        mdiv = BeautifulSoup(navmenu)
        items = mdiv.findAll('li', {'class':''})
        ino = 1
        for item in items:
            mlist['%02d%s'%(ino,item.text)]=item.find('a')['href']
            ino+=1
        return (mlist,5,self.icon)

    def get_second(self,iurl):
        """
        Get the list of shows.
        :return: list
        """
        shows = []
        h = HTMLParser.HTMLParser()

        html = requests.get(iurl, headers=self.hdr).text
        html = re.findall('(<div\s*class="news-box\sdark.+?)<div\s*id="side"',html,re.DOTALL)[0]
        mdiv = BeautifulSoup(html)
        items = mdiv.findAll('div', {'class':re.compile('^four-col')})
        for item in items:
            title = h.unescape(item.find('a', {'class':'serial_title'}).text)
            url = item.find('a', {'class':'serial_img'}).get('href')
            o = urlparse.urlparse(url)
            path = o.path.split('/')
            path = '/'.join((path[0],path[1],'episodes',path[2]))
            url = urlparse.urlunparse((o.scheme, o.netloc, path, o.params, o.query, o.fragment))
            thumb = item.find('a', {'class':'serial_img'}).find('img')['src']
            shows.append((title.encode('utf8'),thumb,url.encode('utf8')))

        return (shows,7)
        
    def get_items(self,iurl):
        episodes = []
        html = requests.get(iurl).text
        thumb = re.findall('<img\s*src="([^"]+)',html,re.DOTALL)[0]
        html = re.findall('full_episode".+?>(.+?</ul>)',html,re.DOTALL)[0]
        mdiv = BeautifulSoup(html)
        items = mdiv.findAll('li')
        for item in items:
            title = item.find('div', {'class':'episode_date'}).text + ' - ' + item.find('div', {'class':'episode_link'}).text
            url = item.find('div', {'class':'episode_link'}).find('a')['href']
            episodes.append((title, thumb, url))
                    
        return (episodes,8) 

    def get_videos(self,iurl):
        videos = []
        html = requests.get(iurl).text
        html = re.findall('(<div\sclass="tab_contents.+?>.+?)<div\sclass="news-box',html,re.DOTALL)[0]
        mdiv = BeautifulSoup(html)
        items = mdiv.findAll('li')
        prog_per = 0
        numlink = 0
        pDialog = xbmcgui.DialogProgress()
        pDialog.create('Deccan Delight', 'Collecting Links...')
        for item in items:
            vid_link = item.find('a')['href']
            self.resolve_media(vid_link,videos)
            prog_per += 100/len(items)
            numlink += 1
            if (pDialog.iscanceled()): return videos
            pDialog.update(prog_per, 'Collected Links... %s of %s'%(numlink,len(items)))
        return videos
